# Source me to get the correct configure/build/run environment

# Store tracing and disable (module is *way* too verbose)
{ tracing_=${-//[^x]/}; set +x; } 2>/dev/null

module_load() {
  echo "+ module load $*"
  module load $*
}
module_unload() {
  echo "+ module unload $*"
  module unload $*
}
module_purge() {
  echo "+ module purge"
  module purge
}

. /spack/share/spack/setup-env.sh
spack env activate -pd /spack_env

export FC=$(which nvfortran)
export CC=$(which nvc)
export CXX=$(which nvc++)

export fypp_DIR=/usr/local/lib/python3.10/dist-packages
export pyyaml_DIR=/usr/local/lib/python3.10/dist-packages

$FC --version

# Setting required for bit reproducibility with Intel MKL:
export MKL_CBWR=AUTO,STRICT

# Record the RPATH in the executable
export LD_RUN_PATH=$LD_LIBRARY_PATH

# Restore tracing to stored setting
{ if [[ -n "$tracing_" ]]; then set -x; else set +x; fi } 2>/dev/null

export ECBUILD_TOOLCHAIN="./toolchain.cmake"
