## Directory overview

The directory holds the following subfolders:
- `/ecwam_bundle`: the actual *ecWAM* model code, containing the source and cmake files, from the [DE360 gitlab repository](https://gitlab-hpc.cineca.it/de360/ecwam), updated to the `deliverable_october_2023` tag. Contains the subdirectories:
    - The `/ecwam_bundle/ecwam/ecwam` used to compile the `MPI+OpenMP` version of the model
    - The `/ecwam_bundle/ecwam/ecwam_naan-phys-gpu` provides compile options for GPU support
    - The `/ecwam_bundle/ecwam-others` folder holds the `field_api` package. In the same path we will `git clone` and install the `loki` software during the built of the container
- `/spack_build`: contains a standalone version of `Spack`, namely version `0.21.0.dev0`. It can be obtained just cloning the `Spack` repository (as in `git clone -c feature.manyFiles=true https://github.com/spack/spack.git`), selecting the corresponding version
- `/spack_recipes`: contains all the handmade files needed for installing *ecWAM* via `Spack`. Contains the subdirectories:
    - `/mirror`: holds the `tar.gz` of some specific packages provided by *ECMWF* and installed via spack
    - `/recipes`: the spack recipes of the above packages    
    - `/spack_yamls-23.1` and `/spack_yamls-23.1`: additional configuration files for spack, when compiling with `nvhpc@23.1` or `nvhpc@23.9`
    - `spack_env-23.1.yaml` and `spack_env-23.9.yaml`: `spack.yaml` files for handling the installation of *ecWAM* in a `Spack` environment
- `/scripts_for_build`: some handmade scripts used in the built of the container, mainly for installing packages (`loki` and `field_api`), and compiling the model (with `MPI` and `openACC`)


### Handtuned files (todo)

- `/extra_files`: with respect to the original files of the *ecwam* repository, a few changes had to be performed for the code to run in a containerized environment. We store them in this folder to keep track of them. In particular:
    - In the `/ecwam_bundle/ecwam/ecwam/CMakeLists.txt` and `/ecwam_bundle/ecwam/ecwam_naan-phys-gpu/CMakeLists.txt` files we commented out the line 39. This is to avoid using the `multio` package, which is currently giving some issues at compile time 
    - In the `/ecwam_bundle/ecwam/ecwam/share/ecwam/CMakeLists.txt` and `/ecwam_bundle/ecwam/ecwam_naan-phys-gpu/share/ecwam/CMakeLists.txt` files we replaced line 56 with the *fixed* relative path inside the container image