! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM CUDA

USE CUDAFOR
USE OPENACC

IMPLICIT NONE

INTEGER, PARAMETER :: N = 100

REAL*8, DEVICE :: DEV (N)
REAL*8 :: HST (N)
REAL*8, POINTER :: DEV1 (:)

INTEGER :: I
INTEGER :: ISIZE

DO I = 1, N
  HST (I) = REAL (I, 8)
ENDDO

ISIZE = N * KIND (DEV)

CALL ACC_MEMCPY_TO_DEVICE (DEV (:), HST (:), ISIZE)

ALLOCATE (DEV1, MOLD=HST)
!$acc enter data create (DEV1)

!$acc host_data use_device (DEV1)
CALL ACC_MEMCPY_TO_DEVICE (DEV1 (:), HST (:), ISIZE)
!$acc end host_data

!$acc serial present (DEV1)
DO I = 1, N
  PRINT *, I, DEV1 (I)
ENDDO
!$acc end serial

END
