! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM ENSURE_HOST
        ! TEST IF DATA ARE CORRECTLY TRANSFERED ON CPU WHEN CALLING ENSURE_HOST
        USE FIELD_MODULE
        IMPLICIT NONE
        TYPE(FIELD_2D_OWNER) :: W
        REAL(KIND=JPRB), POINTER :: D_GPU(:,:), D_CPU(:,:)
        INTEGER :: I,J

        CALL W%INIT([10,1], [21,11], PERSISTENT=.TRUE.)
        CALL W%GET_HOST_DATA_RDWR(D_CPU)
        D_CPU=7

        CALL W%GET_DEVICE_DATA_RDWR(D_GPU)

        !$ACC SERIAL PRESENT(D_GPU)
        DO I=1,11
          DO J=10,21
            D_GPU(J,I)=I*J
          END DO
        END DO
        !$ACC END SERIAL

#ifdef _CUDA
        ! DATA SHOULD ALL BE 7 BECAUSE THEY HAVEN'T MOVED BACK FROM GPU
        ! YET. BUT IF OPENACC WAS DESACTIVATED THEN THE VALUES HAVE
        ! ALREADY CHANGED SINCE IT ALWAYS HAPPEN ON THE CPU MAIN MEMORY
        IF ( .NOT. ALL(D_CPU == 7))THEN
             ERROR STOP
        END IF
#endif /* _CUDA */

        CALL W%ENSURE_HOST()

        IF (ASSOCIATED(W%DEVPTR)) THEN
                ERROR STOP
        END IF
#ifdef _CUDA
        IF (ALLOCATED(W%DEVDATA)) THEN
                ERROR STOP
        END IF
#endif /* _CUDA */

        DO I=1,11
          DO J=10,21
            IF (D_CPU(J,I)/=I*J) THEN
                ERROR STOP
            END IF
          END DO
        END DO
END PROGRAM ENSURE_HOST
