! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM FINAL_WRAPPER_GPU_4D
        ! TEST IF DATA ARE CORRECTLY TRANSFERED ON CPU WHEN CALLING FNAL
        USE FIELD_MODULE
        IMPLICIT NONE
        TYPE(FIELD_4D_WRAPPER) :: W
        REAL(KIND=JPRB), ALLOCATABLE :: D(:,:,:,:)
        REAL(KIND=JPRB), POINTER :: D_GPU(:,:,:,:), D_CPU(:,:,:,:)
        INTEGER :: I,J,K,L

        ALLOCATE(D(10:21,11,3:7,20:30))
        D=7

        CALL W%INIT(D, LBOUNDS=[10,1,3,20])
        CALL W%GET_DEVICE_DATA_RDWR(D_GPU)

        !$ACC SERIAL PRESENT(D_GPU)
        DO I=12,21
          DO J=1,11
            DO K=3,7
              DO L=20,30
                D_GPU(I,J,K,L)=I*J*K*L
              END DO
            END DO
          END DO
        END DO
        !$ACC END SERIAL

#ifdef _CUDA
        ! DATA SHOULD ALL BE 7 BECAUSE THEY HAVEN'T MOVED BACK FROM GPU
        ! YET. BUT IF OPENACC WAS DESACTIVATED THEN THE VALUES HAVE
        ! ALREADY CHANGED SINCE IT ALWAYS HAPPEN ON THE CPU MAIN MEMORY
        IF ( .NOT. ALL(D == 7))THEN
             ERROR STOP
        END IF
#endif /* _CUDA */

        CALL W%FINAL()

        IF (ASSOCIATED(W%PTR)) THEN
                ERROR STOP
        END IF
        IF (ASSOCIATED(W%DEVPTR)) THEN
                ERROR STOP
        END IF
#ifdef _CUDA
        IF (ALLOCATED(W%DEVDATA)) THEN
                ERROR STOP
        END IF
        IF (ASSOCIATED(W%DATA)) THEN
                ERROR STOP
        END IF
#endif /* _CUDA */

        DO I=12,21
          DO J=1,11
            DO K=3,7
              DO L=20,30
                IF(D(I,J,K,L) /= I*J*K*L)THEN
                   ERROR STOP
                ENDIF
              END DO
            END DO
          END DO
        END DO
END PROGRAM FINAL_WRAPPER_GPU_4D
