! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM FINAL_WRAPPER_PACKED_GPU
        ! TEST IF DESTROYING THE PACKED WRAPPER DOESN'T DESTROY THE WRAPPED DATA

        USE FIELD_MODULE
        IMPLICIT NONE
        TYPE(FIELD_2D_WRAPPER_PACKED) :: U, W
        REAL(KIND=JPRB), POINTER :: U_GPU(:,:), W_GPU(:,:)
        REAL(KIND=JPRB), POINTER, CONTIGUOUS :: PTR(:,:,:)
        INTEGER :: I, J

        PTR => MALLOC_HOST_PINNED_3D([10, 2], 10)
        PTR = 7._JPRB

        CALL U%INIT(PTR, 1)
        CALL W%INIT(PTR, 2)
        CALL U%GET_DEVICE_DATA_RDWR(U_GPU)
        CALL W%GET_DEVICE_DATA_RDWR(W_GPU)

        !$ACC SERIAL PRESENT(U_GPU,W_GPU)
        DO I=1,10
          DO J=1,10
            U_GPU(J,I)=I*J
            W_GPU(J,I)=2*I*J
          END DO
        END DO
        !$ACC END SERIAL

#ifdef _CUDA
        ! DATA SHOULD ALL BE 7 BECAUSE THEY HAVEN'T MOVED BACK FROM GPU
        ! YET. BUT IF OPENACC WAS DESACTIVATED THEN THE VALUES HAVE
        ! ALREADY CHANGED SINCE IT ALWAYS HAPPEN ON THE CPU MAIN MEMORY
        IF ( .NOT. ALL(PTR == 7))THEN
             ERROR STOP
        END IF
#endif /* _CUDA */

        CALL U%FINAL()
        CALL W%FINAL()

        IF (ASSOCIATED(U%PTR)) THEN
                ERROR STOP
        END IF
        IF (ASSOCIATED(U%DEVPTR)) THEN
                ERROR STOP
        END IF
        IF (ASSOCIATED(W%PTR)) THEN
                ERROR STOP
        END IF
        IF (ASSOCIATED(W%DEVPTR)) THEN
                ERROR STOP
        END IF
        IF (ALLOCATED(W%DEVDATA)) THEN
                ERROR STOP
        END IF
        IF (ASSOCIATED(W%DATA)) THEN
                ERROR STOP
        END IF

        IF (.NOT. ASSOCIATED(PTR)) THEN
                ERROR STOP
        END IF

        DO I=1,10
          DO J=1,10
            IF(PTR(J,1,I) /= I*J)THEN
               ERROR STOP
            ENDIF
            IF(PTR(J,2,I) /= 2*I*J)THEN
               ERROR STOP
            ENDIF
          END DO
        END DO

END PROGRAM FINAL_WRAPPER_PACKED_GPU
