! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM GET_STATS_NO_OPENACC
#ifndef _OPENACC
        ! TEST IF STATS ARE CORRECTLY COMPUTED WHEN OPENACC IS DESACTIVATED
        USE FIELD_MODULE
        IMPLICIT NONE
        TYPE(FIELD_2D_WRAPPER) :: W
        REAL(KIND=JPRB), ALLOCATABLE :: D(:,:)
        REAL(KIND=JPRB), POINTER :: D_GPU(:,:)
        REAL(KIND=JPRB), POINTER :: D_CPU(:,:)

        ALLOCATE(D(10,10))

        CALL W%INIT(D)
        CALL W%GET_DEVICE_DATA_RDONLY(D_GPU)
        CALL W%GET_DEVICE_DATA_RDONLY(D_GPU)
        ! SHOULD BE 0 BECAUSE THE DATA HAVE NOT MOVED SINCE OPENACC IS DESACTIVATED
        IF (W%STATS%TRANSFER_CPU_TO_GPU /= 0) THEN
                ERROR STOP
        END IF
        IF (W%STATS%TOTAL_TIME_TRANSFER_CPU_TO_GPU /= 0) THEN
                ERROR STOP
        END IF

        IF (.NOT. ASSOCIATED(W%PTR, W%DEVPTR)) THEN
                ERROR STOP
        END IF

        CALL W%FINAL
#endif /* _OPENACC */
END PROGRAM GET_STATS_NO_OPENACC
