! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM INIT_OWNER_GPU
        ! TEST IF DATA ARE CORRECTLY TRANSFERED ON GPU

        USE FIELD_MODULE
        IMPLICIT NONE
        TYPE(FIELD_2D_OWNER) :: O
        REAL(KIND=JPRB), POINTER :: PTR_CPU(:,:)
        REAL(KIND=JPRB), POINTER :: PTR_GPU(:,:)
        LOGICAL :: RES
        INTEGER :: I,J

        CALL O%INIT([10,1],[21,11], PERSISTENT=.TRUE.)
        CALL O%GET_HOST_DATA_RDWR(PTR_CPU)
        PTR_CPU=42

        CALL O%GET_DEVICE_DATA_RDONLY(PTR_GPU)
        !$ACC SERIAL PRESENT(PTR_GPU) COPY(RES)
        RES=.TRUE.
        DO I=10,21
        DO J=1,11
        IF(PTR_GPU(I,J) /= 42) THEN
                RES = .FALSE.
        END IF
        END DO
        END DO
        !$ACC END SERIAL

        IF (.NOT. RES) THEN
                ERROR STOP
        END IF
END PROGRAM INIT_OWNER_GPU
