! (C) Copyright 2022- ECMWF.
! (C) Copyright 2022- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.


PROGRAM INIT_WRAPPER_PACKED_GPU
        ! TEST IF PACKED WRAPPER IS REALLY WRAPPING DATA
        ! IF IT IS WRAPPING THEN MODIFYING THE WRAPED DATA SHOULD BE SEEN IN
        ! WRAPPER TOO

        USE FIELD_MODULE
        IMPLICIT NONE
        TYPE(FIELD_2D_WRAPPER_PACKED) :: U, V, W
        REAL(KIND=JPRB), POINTER :: U_GPU(:,:), V_GPU(:,:), W_GPU(:,:)
        REAL(KIND=JPRB), POINTER, CONTIGUOUS :: PTR(:,:,:)
        LOGICAL :: RES
        INTEGER :: I,J

        PTR => MALLOC_HOST_PINNED_3D([10, 3], 10)
        PTR = 7._JPRB

        CALL U%INIT(PTR, 1)
        CALL V%INIT(PTR, 2)
        CALL W%INIT(PTR, 3)

        PTR(:,1,:) = 1._JPRB
        PTR(:,2,:) = 2._JPRB
        PTR(:,3,:) = 3._JPRB

        CALL U%GET_DEVICE_DATA_RDONLY(U_GPU)
        CALL V%GET_DEVICE_DATA_RDONLY(V_GPU)
        CALL W%GET_DEVICE_DATA_RDONLY(W_GPU)

        !$ACC SERIAL PRESENT(U_GPU,V_GPU,W_GPU) COPY(RES)
        RES=.TRUE.
        DO I=1,10
          DO J=1,10
            IF(U_GPU(I,J) /= 1._JPRB) THEN
                RES = .FALSE.
            END IF
            IF(V_GPU(I,J) /= 2._JPRB) THEN
                RES = .FALSE.
            END IF
            IF(W_GPU(I,J) /= 3._JPRB) THEN
                RES = .FALSE.
            END IF
          END DO
        END DO
        !$ACC END SERIAL

        IF (.NOT. RES) THEN
                ERROR STOP
        END IF

END PROGRAM INIT_WRAPPER_PACKED_GPU
