! (C) Copyright 1989- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

      MODULE YOWCOUT

      USE PARKIND_WAVE, ONLY : JWIM, JWRB, JWRU

      IMPLICIT NONE

!*    ** *COUT*  OUTPUT POINTS INDICES AND FLAGS.

      INTEGER(KIND=JWIM), PARAMETER :: NTRAIN=3 
      INTEGER(KIND=JWIM), PARAMETER :: JPPFLAG=69+3*NTRAIN+5 !!!! change also in scripts: wave_setgflag
      INTEGER(KIND=JWIM), PARAMETER :: NREAL=14 
      INTEGER(KIND=JWIM), PARAMETER :: NIPRMINFO=5
      INTEGER(KIND=JWIM), PARAMETER :: NINFOBOUT=3

      CHARACTER(LEN=14), ALLOCATABLE :: COUTT(:)
      CHARACTER(LEN=14) :: COUTLST 
      CHARACTER(LEN=14), ALLOCATABLE :: COUTS(:) 
      CHARACTER(LEN=14), ALLOCATABLE :: CASS(:) 

      CHARACTER(LEN=256):: COUTDESCRIPTION(JPPFLAG)
      CHARACTER(LEN=33) :: COUTNAME(JPPFLAG)

      LOGICAL :: FFLAG(JPPFLAG) 
      LOGICAL :: FFLAG20 
      LOGICAL :: GFLAG(JPPFLAG) 
      LOGICAL :: GFLAG20 
      LOGICAL :: NFLAG(JPPFLAG) 
      LOGICAL :: NFLAGALL 
      LOGICAL :: UFLAG(JPPFLAG) 
      LOGICAL :: LFDB 
      LOGICAL :: LOUTINT 
      LOGICAL :: LWFLUXOUT
      LOGICAL :: LSECONDORDER
      LOGICAL :: LRSTST0
      LOGICAL :: LWAMANOUT
      LOGICAL :: LWAMANOUT_ORIG
      LOGICAL :: LRSTPARALR
      LOGICAL :: LRSTPARALW
      LOGICAL :: LRSTINFDAT
      LOGICAL :: LLPARTITION
      LOGICAL :: LWAM_USE_IO_SERV
      LOGICAL :: LOUTMDLDCP

      INTEGER(KIND=JWIM) :: NWRTOUTWAM=1
      INTEGER(KIND=JWIM) :: NIPRMOUT 
      INTEGER(KIND=JWIM) :: NGOUT
      INTEGER(KIND=JWIM), ALLOCATABLE :: IJAR(:)
      INTEGER(KIND=JWIM) :: NOUTT
      INTEGER(KIND=JWIM) :: NOUTS
      INTEGER(KIND=JWIM) :: NASS
      INTEGER(KIND=JWIM) :: IRWDIR,IRCD,IRU10,IRHS,IRTP,IRT1,IRPHIAW,IRPHIOC,IRTAUOC
      INTEGER(KIND=JWIM) :: IRHSWS, IRT1WS, IRBATHY
      INTEGER(KIND=JWIM) :: IRALTHS,IRALTHSC,IRALTRC
      INTEGER(KIND=JWIM) :: IFRSTPARTI
      INTEGER(KIND=JWIM) :: IPFGTBL(JPPFLAG+1)
      INTEGER(KIND=JWIM), PARAMETER :: KDEL=1
      INTEGER(KIND=JWIM), PARAMETER :: MDEL=1
      INTEGER(KIND=JWIM) :: IPRMINFO(JPPFLAG,NIPRMINFO)
      INTEGER(KIND=JWIM) :: ITOBOUT(JPPFLAG)
      INTEGER(KIND=JWIM), ALLOCATABLE, DIMENSION(:,:) :: INFOBOUT

!*     VARIABLE.   TYPE.     PURPOSE.
!      ---------   -------   --------
!      *NTRAIN*    INTEGER   MAXIMUM NUMBER OF SWELL TRAINS.
!      *NREAL*     INTEGER   NUMBER OF REAL FIELDS IN RESTART FILE
!      *NIPRMINFO* INTEGER   NUMBER OF AUXILLIARY INFORMATION ITEMS ON OUTPUT INTEGRATED PARAMETERS
!      *NINFOBOUT* INTEGER   NUMBER OF AUXILLIARY INFORMATION NEEDED TO ENCODE IN GRIB THE INTEGRATED PARAMETERS
!      *COUTT*     CHAR*14   OUTPUT TIMES.
!      *COUTLST*   CHAR*14   LAST OUTPUT TIME.
!      *COUTS*     CHAR*14   OUTPUT TIMES FOR THE SPECTRA.
!      *CASS*      CHAR*14   ASSIMILATION TIMES.
!      *COUTNAME   CHAR*33 NAME OF THE OUTPUT VARIABLES
!      *COUTDESCRIPTION CHAR*256 CHARACTER DESCRIPTION OF THE OUTPUT VARIABLES
!      *FFLAG*     LOGICAL   FILE  OUTPUT FLAG FOR EACH OUTPUT TYPE.
!      *FFLAG20*   LOGICAL   .TRUE. IF OUTPUT IS WRITTEN TO UNIT IU20.
!      *GFLAG*     LOGICAL   GRIB  OUTPUT FLAG FOR EACH OUTPUT TYPE.
!      *GFLAG20*   LOGICAL   .TRUE. IF OUTPUT IS GRIBBED TO UNIT IU30.
!      *NFLAG*     LOGICAL   NORM OUTPUT FLAG FOR EACH OUTPUT TYPE.
!      *NFLAGALL*  LOGICAL   .TRUE. IF NORM OUTPUT IS REQUESTED.
!      *UFLAG*     LOGICAL   FLAG WHETHER OUTPUT GRID FIELD IS USED
!                            IN THE ASSIMILATION SCHEME
!      *LFDB*      LOGICAL   .TRUE. IF OUTPUT IS SENT TO FDB.
!      *LOUTINT*   LOGICAL   .TRUE. IF OUTINT WAS CALLED.
!      *NGOUT*     INTEGER   NUMBER OF OUTPUT POINTS.
!      *IJAR*      INTEGER   GRIDPOINT NUMBER OF OUTPUT POINT.
!      *NOUTT*     INTEGER   NUMBER OF OUTPUT TIMES.
!      *NOUTS*     INTEGER   NUMBER OF OUTPUT TIMES FOR THE SPECTRA.
!      *NASS*      INTEGER   NUMBER OF ASSIMILATION TIMES.
!      *IPFGTBL*   INTEGER   TABLE THAT ASSOCIATES EACH INTEGRATED OUTPUT PARAMETER
!                            WITH A SPECIFIC PROCESSOR. IF SET TO -1, IT MEANS THAT
!                            THE PARAMETER IS ONLY NEEDED FOR NORM CALCULATION.
!      *IRWDIR*    INTEGER   INDEX IN IPFGTBL OF WIND DIRECTION
!      *IRCD*      INTEGER   INDEX IN IPFGTBL OF CD
!      *IRU10*     INTEGER   INDEX IN IPFGTBL OF U10 
!      *IRHS*      INTEGER   INDEX IN IPFGTBL OF HS
!      *IRTP*      INTEGER   INDEX IN IPFGTBL OF TP 
!      *IRT1*      INTEGER   INDEX IN IPFGTBL OF T1 
!      *IRPHIAW*   INTEGER   INDEX IN IPFGTBL OF PHIAW
!      *IRPHIOC*   INTEGER   INDEX IN IPFGTBL OF PHIOC
!      *IRTAUOC*   INTEGER   INDEX IN IPFGTBL OF TAUOC
!      *IRHSWS*    INTEGER   INDEX IN IPFGTBL OF HS WINDSEA 
!      *IRT1WS*    INTEGER   INDEX IN IPFGTBL OF T1 WINDSEA 
!      *IRBATHY*   INTEGER   INDEX IN IPFGTBL OF WATER DEPTH
!      *IRALTHS*   INTEGER   INDEX IN IPFGTBL OF ALTIMETER HS
!      *IRALTHSC*  INTEGER   INDEX IN IPFGTBL OF ALTIMETER HS CORRECTED 
!      *IRALTRC*   INTEGER   INDEX IN IPFGTBL OF ALTIMETER RANGE CORRECTION 
!      *IFRSTPARTI*INTEGER   INDEX IN IPFGTBL OF THE FIRST PARTITONED PARAMETERS 
!      *KDEL*      INTEGER   NUMBER OF DIRECTIONS THAT WILL BE WRITTEN
!                            OUT/READ IN WHEN BINARY SPECTRA ARE PRODUCED
!      *MDEL*      INTEGER   NUMBER OF FREQUENCIES THAT WILL BE WRITTEN
!                            OUT/READ IN WHEN BINARY SPECTRA ARE PRODUCED
!      *LWFLUXOUT* LOGICAL   TRUE IF THE OCEAN FLUXES ARE OUTPUT PARAMETERS.
!      *LSECONDORDER*        TRUE IF SECOND ORDER CORRECTION IS COMPUTED
!                            FOR OUTPUT INTEGRATED PARAMETERS.
!      *LRSTST0    LOGICAL   TRUE IF GRIB HEADER HAVE TO BE RESET
!                            SUCH THAT THE FORECAST STEP POINTS TO
!                            THE START OF THE RUN.
!      *LWAMANOUT* LOGICAL   CONTROLS WHETHER FIELDS WILL BE WRITTEN AT 
!                            ANALYSIS TIME OR NOT. (USEFUL WHEN WAVE DATA
!                            ASSIMILATION IS DONE IN MORE THAN ONE TRAJECTORY.)
!      *LRSTPARALR*LOGICAL   TRUE WILL READ BINARY RESTART FILES IN PARALLEL (i.e. PER MPI TASK)
!      *LRSTPARALW*LOGICAL   TRUE WILL WRITE BINARY RESTART FILES IN PARALLEL (i.e. PER MPI TASK)
!      *LRSTINFDAT*LOGICAL   TRUE WILL WRITE AN ADDITIONAL wamfile WITH DATE/TIME INFO
!      *LLPARTITION*         TRUE IF ANY SWELL PARTITION PARAMETER IS TO BE OUPUT
!      *NWRTOUTWAM INTEGER   CONTROLS THE STRIDE WITH WHICH FDB OUTPUT PE's
!                            ARE SELECTED (BY DEFAULT = 1)
!      *NIPRMOUT* INTEGER    ACTUAL TOTAL NUMBER OF OUTPUT INTEGRATED PARAMETERS 
!      *IPRMINFO* INTEGER    AUXILIARY INFORMATION FOR OUTPUT OF INTEGRATED PARAMETERS
!                            IPRMINFO(:,1)  : GRIB TABLE NUMBER.
!                            IPRMINFO(:,2)  : GRIB PARAMETER IDENTIFIER.
!                            IPRMINFO(:,3)  : GRIB REFERENCE LEVEL IN FULL METER.
!                            IPRMINFO(:,4)  : 1 IF SEA ICE MASK IS IMPOSED ON OUTPUT FIELD.
!                            IPRMINFO(:,5)  : 1 IF TOO SHALLOW POINTS ARE SET TO MISSING.
!      *ITOBOUT*  INTEGER    GIVES THE INDEX IN BOUT OF THE INTEGRATED FIELDS THAT ARE ACTUALLY OUTPUT
!      *INFOBOUT*            AUXILIARY INFORMATION TO ENCODE INTEGRATED PARAMETERS IN GRIB
!                            INFOBOUT(:,1)  : GRIB TABLE NUMBER.
!                            INFOBOUT(:,2)  : GRIB PARAMETER IDENTIFIER.
!                            INFOBOUT(:,3)  : GRIB REFERENCE LEVEL IN FULL METER.
!      *LWAM_USE_IO_SERV*    LOGICAL   CONTROLS WHETHER WAVE MODEL SHOULD USE IFS IO SERVER
!      *LOUTMDLDCP*          LOGICAL, CONTROLS WHETHER THE MODEL MPI DECOMPOSITION IS WRITTEN OUT TO A FILE (see OUTMDLDCP) 
! ----------------------------------------------------------------------
      END MODULE YOWCOUT
