! (C) Copyright 2022- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE YOWFIELD_MOD

   USE PARKIND_WAVE, ONLY : JWRB, JWIM
   USE FIELD_MODULE, ONLY : FIELD_3D_WRAPPER, FIELD_3D, FIELD_INT2D, FIELD_INT2D_WRAPPER, FIELD_2D, FIELD_2D_WRAPPER, &
 &                          FIELD_INT3D, FIELD_INT3D_WRAPPER, FIELD_4D, FIELD_4D_WRAPPER, FIELD_INT4D, FIELD_INT4D_WRAPPER
   IMPLICIT NONE

   TYPE FREQUENCY_FIELD
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: WAVNUM=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: CINV=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: CGROUP=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: XK2CG=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: OMOSNH2KD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: STOKFAC=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:), POINTER :: CIWA=>NULL()
          CLASS(FIELD_3D), POINTER :: F_WAVNUM=>NULL()
          CLASS(FIELD_3D), POINTER :: F_CINV=>NULL()
          CLASS(FIELD_3D), POINTER :: F_CGROUP=>NULL()
          CLASS(FIELD_3D), POINTER :: F_XK2CG=>NULL()
          CLASS(FIELD_3D), POINTER :: F_OMOSNH2KD=>NULL()
          CLASS(FIELD_3D), POINTER :: F_STOKFAC=>NULL()
          CLASS(FIELD_3D), POINTER :: F_CIWA=>NULL()
      CONTAINS
         PROCEDURE :: INIT => FREQUENCY_FIELD_INIT
         PROCEDURE :: UPDATE_VIEW => FREQUENCY_UPDATE_VIEW
   END TYPE FREQUENCY_FIELD

   TYPE ENVIRONMENT_FIELD
          INTEGER(KIND=JWIM), DIMENSION(:), POINTER :: INDEP=>NULL()
          INTEGER(KIND=JWIM), DIMENSION(:), POINTER :: IODP=>NULL()
          INTEGER(KIND=JWIM), DIMENSION(:), POINTER :: IOBND=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: DELLAM1=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: COSPHM1=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: DEPTH=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: EMAXDPT=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: UCUR=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: VCUR=>NULL()
          CLASS(FIELD_INT2D), POINTER :: F_INDEP=>NULL()
          CLASS(FIELD_INT2D), POINTER :: F_IODP=>NULL()
          CLASS(FIELD_INT2D), POINTER :: F_IOBND=>NULL()
          CLASS(FIELD_2D), POINTER :: F_DELLAM1=>NULL()
          CLASS(FIELD_2D), POINTER :: F_COSPHM1=>NULL()
          CLASS(FIELD_2D), POINTER :: F_DEPTH=>NULL()
          CLASS(FIELD_2D), POINTER :: F_EMAXDPT=>NULL()
          CLASS(FIELD_2D), POINTER :: F_UCUR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_VCUR=>NULL()
      CONTAINS
         PROCEDURE :: INIT => ENVIRONMENT_FIELD_INIT
         PROCEDURE :: UPDATE_VIEW => ENVIRONMENT_UPDATE_VIEW
   END TYPE ENVIRONMENT_FIELD

   TYPE FORCING_FIELDS_FIELD
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: UWND=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: VWND=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: AIRD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: WSTAR=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: CICOVER=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: CITHICK=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: LKFR=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: UCUR=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: VCUR=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: WSWAVE=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: WDWAVE=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: UFRIC=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUW=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUWDIR=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: Z0M=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: Z0B=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: CHRNCK=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: XLON=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: YLAT=>NULL()
          CLASS(FIELD_2D), POINTER :: F_UWND=>NULL()
          CLASS(FIELD_2D), POINTER :: F_VWND=>NULL()
          CLASS(FIELD_2D), POINTER :: F_AIRD=>NULL()
          CLASS(FIELD_2D), POINTER :: F_WSTAR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_CICOVER=>NULL()
          CLASS(FIELD_2D), POINTER :: F_CITHICK=>NULL()
          CLASS(FIELD_2D), POINTER :: F_LKFR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_UCUR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_VCUR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_WSWAVE=>NULL()
          CLASS(FIELD_2D), POINTER :: F_WDWAVE=>NULL()
          CLASS(FIELD_2D), POINTER :: F_UFRIC=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUW=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUWDIR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_Z0M=>NULL()
          CLASS(FIELD_2D), POINTER :: F_Z0B=>NULL()
          CLASS(FIELD_2D), POINTER :: F_CHRNCK=>NULL()
          CLASS(FIELD_2D), POINTER :: F_XLON=>NULL()
          CLASS(FIELD_2D), POINTER :: F_YLAT=>NULL()
      CONTAINS
         PROCEDURE :: INIT => FORCING_FIELDS_FIELD_INIT
         PROCEDURE :: UPDATE_VIEW => FORCING_FIELDS_UPDATE_VIEW
   END TYPE FORCING_FIELDS_FIELD

   TYPE WAVE2OCEAN_FIELD
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NSWH=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NMWP=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NPHIEPS=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOPHIF=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NTAUOC=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOTAUX=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOTAUY=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOUSTOKES=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOVSTOKES=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOSTRN=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: NEMOWSWAVE=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NSWH=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NMWP=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NPHIEPS=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOPHIF=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NTAUOC=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOTAUX=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOTAUY=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOUSTOKES=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOVSTOKES=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOSTRN=>NULL()
          CLASS(FIELD_2D), POINTER :: F_NEMOWSWAVE=>NULL()
      CONTAINS
         PROCEDURE :: INIT => WAVE2OCEAN_FIELD_INIT
         PROCEDURE :: UPDATE_VIEW => WAVE2OCEAN_UPDATE_VIEW
   END TYPE WAVE2OCEAN_FIELD

   TYPE INTGT_PARAM_FIELDS_FIELD
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: WSEMEAN=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: WSFMEAN=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: USTOKES=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: VSTOKES=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: PHIEPS=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: PHIOCD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: PHIAW=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUOC=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUXD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUYD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUOCXD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: TAUOCYD=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: STRNMS=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: ALTWH=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: CALTWH=>NULL()
          REAL(KIND=JWRB), DIMENSION(:), POINTER :: RALTCOR=>NULL()
          CLASS(FIELD_2D), POINTER :: F_WSEMEAN=>NULL()
          CLASS(FIELD_2D), POINTER :: F_WSFMEAN=>NULL()
          CLASS(FIELD_2D), POINTER :: F_USTOKES=>NULL()
          CLASS(FIELD_2D), POINTER :: F_VSTOKES=>NULL()
          CLASS(FIELD_2D), POINTER :: F_PHIEPS=>NULL()
          CLASS(FIELD_2D), POINTER :: F_PHIOCD=>NULL()
          CLASS(FIELD_2D), POINTER :: F_PHIAW=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUOC=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUXD=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUYD=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUOCXD=>NULL()
          CLASS(FIELD_2D), POINTER :: F_TAUOCYD=>NULL()
          CLASS(FIELD_2D), POINTER :: F_STRNMS=>NULL()
          CLASS(FIELD_2D), POINTER :: F_ALTWH=>NULL()
          CLASS(FIELD_2D), POINTER :: F_CALTWH=>NULL()
          CLASS(FIELD_2D), POINTER :: F_RALTCOR=>NULL()
      CONTAINS
         PROCEDURE :: INIT => INTGT_PARAM_FIELDS_FIELD_INIT
         PROCEDURE :: UPDATE_VIEW => INTGT_PARAM_FIELDS_UPDATE_VIEW
   END TYPE INTGT_PARAM_FIELDS_FIELD

   TYPE SOURCE_CONTRIBS_FIELD
          REAL(KIND=JWRB), DIMENSION(:,:,:), POINTER :: FL1=>NULL()
          REAL(KIND=JWRB), DIMENSION(:,:,:), POINTER :: XLLWS=>NULL()
          INTEGER(KIND=JWIM), DIMENSION(:), POINTER :: MIJ=>NULL()
          CLASS(FIELD_4D), POINTER :: F_FL1=>NULL()
          CLASS(FIELD_4D), POINTER :: F_XLLWS=>NULL()
          CLASS(FIELD_INT2D), POINTER :: F_MIJ=>NULL()
      CONTAINS
         PROCEDURE :: INIT => SOURCE_CONTRIBS_FIELD_INIT
         PROCEDURE :: UPDATE_VIEW => SOURCE_CONTRIBS_UPDATE_VIEW
   END TYPE SOURCE_CONTRIBS_FIELD

   CONTAINS
      FUNCTION WRAP_2D_REAL_FIELD(ARR) RESULT(FIELD)
        REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN) :: ARR
         CLASS(FIELD_2D_WRAPPER), POINTER :: FIELD

         ALLOCATE(FIELD)
         CALL FIELD%INIT(ARR)
      END FUNCTION WRAP_2D_REAL_FIELD

      FUNCTION WRAP_3D_REAL_FIELD(ARR) RESULT(FIELD)
        REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN) :: ARR
         CLASS(FIELD_3D_WRAPPER), POINTER :: FIELD

         ALLOCATE(FIELD)
         CALL FIELD%INIT(ARR)
      END FUNCTION WRAP_3D_REAL_FIELD

      FUNCTION WRAP_4D_REAL_FIELD(ARR) RESULT(FIELD)
        REAL(KIND=JWRB), DIMENSION(:,:,:,:), INTENT(IN) :: ARR
         CLASS(FIELD_4D_WRAPPER), POINTER :: FIELD

         ALLOCATE(FIELD)
         CALL FIELD%INIT(ARR)
      END FUNCTION WRAP_4D_REAL_FIELD

      FUNCTION WRAP_2D_INT_FIELD(ARR) RESULT(FIELD)
        INTEGER(KIND=JWIM), DIMENSION(:,:), INTENT(IN) :: ARR
         CLASS(FIELD_INT2D_WRAPPER), POINTER :: FIELD

         ALLOCATE(FIELD)
         CALL FIELD%INIT(ARR)
      END FUNCTION WRAP_2D_INT_FIELD

      FUNCTION WRAP_3D_INT_FIELD(ARR) RESULT(FIELD)
        INTEGER(KIND=JWIM), DIMENSION(:,:,:), INTENT(IN) :: ARR
         CLASS(FIELD_INT3D_WRAPPER), POINTER :: FIELD

         ALLOCATE(FIELD)
         CALL FIELD%INIT(ARR)
      END FUNCTION WRAP_3D_INT_FIELD

      FUNCTION WRAP_4D_INT_FIELD(ARR) RESULT(FIELD)
        INTEGER(KIND=JWIM), DIMENSION(:,:,:,:), INTENT(IN) :: ARR
         CLASS(FIELD_INT4D_WRAPPER), POINTER :: FIELD

         ALLOCATE(FIELD)
         CALL FIELD%INIT(ARR)
      END FUNCTION WRAP_4D_INT_FIELD

      SUBROUTINE FREQUENCY_FIELD_INIT(SELF, WAVNUM, CINV, CGROUP, XK2CG, OMOSNH2KD, STOKFAC, CIWA)
          CLASS(FREQUENCY_FIELD), INTENT(INOUT) :: SELF
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: WAVNUM
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: CINV
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: CGROUP
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: XK2CG
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: OMOSNH2KD
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: STOKFAC
          REAL(KIND=JWRB), DIMENSION(:,:,:), INTENT(IN), OPTIONAL :: CIWA

          IF(PRESENT(WAVNUM)) SELF%F_WAVNUM => WRAP_3D_REAL_FIELD(WAVNUM)
          IF(PRESENT(CINV)) SELF%F_CINV => WRAP_3D_REAL_FIELD(CINV)
          IF(PRESENT(CGROUP)) SELF%F_CGROUP => WRAP_3D_REAL_FIELD(CGROUP)
          IF(PRESENT(XK2CG)) SELF%F_XK2CG => WRAP_3D_REAL_FIELD(XK2CG)
          IF(PRESENT(OMOSNH2KD)) SELF%F_OMOSNH2KD => WRAP_3D_REAL_FIELD(OMOSNH2KD)
          IF(PRESENT(STOKFAC)) SELF%F_STOKFAC => WRAP_3D_REAL_FIELD(STOKFAC)
          IF(PRESENT(CIWA)) SELF%F_CIWA => WRAP_3D_REAL_FIELD(CIWA)
      END SUBROUTINE FREQUENCY_FIELD_INIT
  
      SUBROUTINE FREQUENCY_UPDATE_VIEW(SELF, BLOCK_INDEX)
          CLASS(FREQUENCY_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), INTENT(IN) :: BLOCK_INDEX

          IF(ASSOCIATED(SELF%F_WAVNUM)) SELF%WAVNUM => SELF%F_WAVNUM%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CINV)) SELF%CINV => SELF%F_CINV%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CGROUP)) SELF%CGROUP => SELF%F_CGROUP%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_XK2CG)) SELF%XK2CG => SELF%F_XK2CG%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_OMOSNH2KD)) SELF%OMOSNH2KD => SELF%F_OMOSNH2KD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_STOKFAC)) SELF%STOKFAC => SELF%F_STOKFAC%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CIWA)) SELF%CIWA => SELF%F_CIWA%GET_VIEW(BLOCK_INDEX)
      END SUBROUTINE FREQUENCY_UPDATE_VIEW

      SUBROUTINE ENVIRONMENT_FIELD_INIT(SELF, INDEP, IODP, IOBND, DELLAM1, COSPHM1, DEPTH, EMAXDPT, UCUR, VCUR)
          CLASS(ENVIRONMENT_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), DIMENSION(:,:), INTENT(IN), OPTIONAL :: INDEP
          INTEGER(KIND=JWIM), DIMENSION(:,:), INTENT(IN), OPTIONAL :: IODP
          INTEGER(KIND=JWIM), DIMENSION(:,:), INTENT(IN), OPTIONAL :: IOBND
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: DELLAM1
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: COSPHM1
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: DEPTH
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: EMAXDPT
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: UCUR
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: VCUR

          IF(PRESENT(INDEP)) SELF%F_INDEP => WRAP_2D_INT_FIELD(INDEP)
          IF(PRESENT(IODP)) SELF%F_IODP => WRAP_2D_INT_FIELD(IODP)
          IF(PRESENT(IOBND)) SELF%F_IOBND => WRAP_2D_INT_FIELD(IOBND)
          IF(PRESENT(DELLAM1)) SELF%F_DELLAM1 => WRAP_2D_REAL_FIELD(DELLAM1)
          IF(PRESENT(COSPHM1)) SELF%F_COSPHM1 => WRAP_2D_REAL_FIELD(COSPHM1)
          IF(PRESENT(DEPTH)) SELF%F_DEPTH => WRAP_2D_REAL_FIELD(DEPTH)
          IF(PRESENT(EMAXDPT)) SELF%F_EMAXDPT => WRAP_2D_REAL_FIELD(EMAXDPT)
          IF(PRESENT(UCUR)) SELF%F_UCUR => WRAP_2D_REAL_FIELD(UCUR)
          IF(PRESENT(VCUR)) SELF%F_VCUR => WRAP_2D_REAL_FIELD(VCUR)
      END SUBROUTINE ENVIRONMENT_FIELD_INIT
  
      SUBROUTINE ENVIRONMENT_UPDATE_VIEW(SELF, BLOCK_INDEX)
          CLASS(ENVIRONMENT_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), INTENT(IN) :: BLOCK_INDEX

          IF(ASSOCIATED(SELF%F_INDEP)) SELF%INDEP => SELF%F_INDEP%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_IODP)) SELF%IODP => SELF%F_IODP%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_IOBND)) SELF%IOBND => SELF%F_IOBND%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_DELLAM1)) SELF%DELLAM1 => SELF%F_DELLAM1%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_COSPHM1)) SELF%COSPHM1 => SELF%F_COSPHM1%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_DEPTH)) SELF%DEPTH => SELF%F_DEPTH%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_EMAXDPT)) SELF%EMAXDPT => SELF%F_EMAXDPT%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_UCUR)) SELF%UCUR => SELF%F_UCUR%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_VCUR)) SELF%VCUR => SELF%F_VCUR%GET_VIEW(BLOCK_INDEX)
      END SUBROUTINE ENVIRONMENT_UPDATE_VIEW

      SUBROUTINE FORCING_FIELDS_FIELD_INIT(SELF, UWND, VWND, AIRD, WSTAR, CICOVER, CITHICK, LKFR, UCUR, VCUR, WSWAVE, WDWAVE,&
          & UFRIC, TAUW, TAUWDIR, Z0M, Z0B, CHRNCK, XLON, YLAT)
          CLASS(FORCING_FIELDS_FIELD), INTENT(INOUT) :: SELF
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: UWND
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: VWND
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: AIRD
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: WSTAR
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: CICOVER
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: CITHICK
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: LKFR
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: UCUR
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: VCUR
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: WSWAVE
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: WDWAVE
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: UFRIC
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUW
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUWDIR
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: Z0M
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: Z0B
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: CHRNCK
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: XLON
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: YLAT

          IF(PRESENT(UWND)) SELF%F_UWND => WRAP_2D_REAL_FIELD(UWND)
          IF(PRESENT(VWND)) SELF%F_VWND => WRAP_2D_REAL_FIELD(VWND)
          IF(PRESENT(AIRD)) SELF%F_AIRD => WRAP_2D_REAL_FIELD(AIRD)
          IF(PRESENT(WSTAR)) SELF%F_WSTAR => WRAP_2D_REAL_FIELD(WSTAR)
          IF(PRESENT(CICOVER)) SELF%F_CICOVER => WRAP_2D_REAL_FIELD(CICOVER)
          IF(PRESENT(CITHICK)) SELF%F_CITHICK => WRAP_2D_REAL_FIELD(CITHICK)
          IF(PRESENT(LKFR)) SELF%F_LKFR => WRAP_2D_REAL_FIELD(LKFR)
          IF(PRESENT(UCUR)) SELF%F_UCUR => WRAP_2D_REAL_FIELD(UCUR)
          IF(PRESENT(VCUR)) SELF%F_VCUR => WRAP_2D_REAL_FIELD(VCUR)
          IF(PRESENT(WSWAVE)) SELF%F_WSWAVE => WRAP_2D_REAL_FIELD(WSWAVE)
          IF(PRESENT(WDWAVE)) SELF%F_WDWAVE => WRAP_2D_REAL_FIELD(WDWAVE)
          IF(PRESENT(UFRIC)) SELF%F_UFRIC => WRAP_2D_REAL_FIELD(UFRIC)
          IF(PRESENT(TAUW)) SELF%F_TAUW => WRAP_2D_REAL_FIELD(TAUW)
          IF(PRESENT(TAUWDIR)) SELF%F_TAUWDIR => WRAP_2D_REAL_FIELD(TAUWDIR)
          IF(PRESENT(Z0M)) SELF%F_Z0M => WRAP_2D_REAL_FIELD(Z0M)
          IF(PRESENT(Z0B)) SELF%F_Z0B => WRAP_2D_REAL_FIELD(Z0B)
          IF(PRESENT(CHRNCK)) SELF%F_CHRNCK => WRAP_2D_REAL_FIELD(CHRNCK)
          IF(PRESENT(XLON)) SELF%F_XLON => WRAP_2D_REAL_FIELD(XLON)
          IF(PRESENT(YLAT)) SELF%F_YLAT => WRAP_2D_REAL_FIELD(YLAT)
      END SUBROUTINE FORCING_FIELDS_FIELD_INIT
  
      SUBROUTINE FORCING_FIELDS_UPDATE_VIEW(SELF, BLOCK_INDEX)
          CLASS(FORCING_FIELDS_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), INTENT(IN) :: BLOCK_INDEX

          IF(ASSOCIATED(SELF%F_UWND)) SELF%UWND => SELF%F_UWND%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_VWND)) SELF%VWND => SELF%F_VWND%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_AIRD)) SELF%AIRD => SELF%F_AIRD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_WSTAR)) SELF%WSTAR => SELF%F_WSTAR%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CICOVER)) SELF%CICOVER => SELF%F_CICOVER%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CITHICK)) SELF%CITHICK => SELF%F_CITHICK%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_LKFR)) SELF%LKFR => SELF%F_LKFR%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_UCUR)) SELF%UCUR => SELF%F_UCUR%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_VCUR)) SELF%VCUR => SELF%F_VCUR%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_WSWAVE)) SELF%WSWAVE => SELF%F_WSWAVE%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_WDWAVE)) SELF%WDWAVE => SELF%F_WDWAVE%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_UFRIC)) SELF%UFRIC => SELF%F_UFRIC%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUW)) SELF%TAUW => SELF%F_TAUW%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUWDIR)) SELF%TAUWDIR => SELF%F_TAUWDIR%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_Z0M)) SELF%Z0M => SELF%F_Z0M%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_Z0B)) SELF%Z0B => SELF%F_Z0B%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CHRNCK)) SELF%CHRNCK => SELF%F_CHRNCK%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_XLON)) SELF%XLON => SELF%F_XLON%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_YLAT)) SELF%YLAT => SELF%F_YLAT%GET_VIEW(BLOCK_INDEX)
      END SUBROUTINE FORCING_FIELDS_UPDATE_VIEW

      SUBROUTINE WAVE2OCEAN_FIELD_INIT(SELF, NSWH, NMWP, NPHIEPS, NEMOPHIF, NTAUOC, NEMOTAUX, NEMOTAUY, NEMOUSTOKES, NEMOVSTOKES,&
          & NEMOSTRN, NEMOWSWAVE)
          CLASS(WAVE2OCEAN_FIELD), INTENT(INOUT) :: SELF
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NSWH
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NMWP
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NPHIEPS
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOPHIF
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NTAUOC
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOTAUX
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOTAUY
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOUSTOKES
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOVSTOKES
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOSTRN
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: NEMOWSWAVE

          IF(PRESENT(NSWH)) SELF%F_NSWH => WRAP_2D_REAL_FIELD(NSWH)
          IF(PRESENT(NMWP)) SELF%F_NMWP => WRAP_2D_REAL_FIELD(NMWP)
          IF(PRESENT(NPHIEPS)) SELF%F_NPHIEPS => WRAP_2D_REAL_FIELD(NPHIEPS)
          IF(PRESENT(NEMOPHIF)) SELF%F_NEMOPHIF => WRAP_2D_REAL_FIELD(NEMOPHIF)
          IF(PRESENT(NTAUOC)) SELF%F_NTAUOC => WRAP_2D_REAL_FIELD(NTAUOC)
          IF(PRESENT(NEMOTAUX)) SELF%F_NEMOTAUX => WRAP_2D_REAL_FIELD(NEMOTAUX)
          IF(PRESENT(NEMOTAUY)) SELF%F_NEMOTAUY => WRAP_2D_REAL_FIELD(NEMOTAUY)
          IF(PRESENT(NEMOUSTOKES)) SELF%F_NEMOUSTOKES => WRAP_2D_REAL_FIELD(NEMOUSTOKES)
          IF(PRESENT(NEMOVSTOKES)) SELF%F_NEMOVSTOKES => WRAP_2D_REAL_FIELD(NEMOVSTOKES)
          IF(PRESENT(NEMOSTRN)) SELF%F_NEMOSTRN => WRAP_2D_REAL_FIELD(NEMOSTRN)
          IF(PRESENT(NEMOWSWAVE)) SELF%F_NEMOWSWAVE => WRAP_2D_REAL_FIELD(NEMOWSWAVE)
      END SUBROUTINE WAVE2OCEAN_FIELD_INIT
  
      SUBROUTINE WAVE2OCEAN_UPDATE_VIEW(SELF, BLOCK_INDEX)
          CLASS(WAVE2OCEAN_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), INTENT(IN) :: BLOCK_INDEX

          IF(ASSOCIATED(SELF%F_NSWH)) SELF%NSWH => SELF%F_NSWH%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NMWP)) SELF%NMWP => SELF%F_NMWP%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NPHIEPS)) SELF%NPHIEPS => SELF%F_NPHIEPS%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOPHIF)) SELF%NEMOPHIF => SELF%F_NEMOPHIF%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NTAUOC)) SELF%NTAUOC => SELF%F_NTAUOC%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOTAUX)) SELF%NEMOTAUX => SELF%F_NEMOTAUX%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOTAUY)) SELF%NEMOTAUY => SELF%F_NEMOTAUY%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOUSTOKES)) SELF%NEMOUSTOKES => SELF%F_NEMOUSTOKES%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOVSTOKES)) SELF%NEMOVSTOKES => SELF%F_NEMOVSTOKES%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOSTRN)) SELF%NEMOSTRN => SELF%F_NEMOSTRN%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_NEMOWSWAVE)) SELF%NEMOWSWAVE => SELF%F_NEMOWSWAVE%GET_VIEW(BLOCK_INDEX)
      END SUBROUTINE WAVE2OCEAN_UPDATE_VIEW

      SUBROUTINE INTGT_PARAM_FIELDS_FIELD_INIT(SELF, WSEMEAN, WSFMEAN, USTOKES, VSTOKES, PHIEPS, PHIOCD, PHIAW, TAUOC, TAUXD,&
          & TAUYD, TAUOCXD, TAUOCYD, STRNMS, ALTWH, CALTWH, RALTCOR)
          CLASS(INTGT_PARAM_FIELDS_FIELD), INTENT(INOUT) :: SELF
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: WSEMEAN
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: WSFMEAN
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: USTOKES
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: VSTOKES
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: PHIEPS
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: PHIOCD
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: PHIAW
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUOC
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUXD
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUYD
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUOCXD
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: TAUOCYD
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: STRNMS
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: ALTWH
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: CALTWH
          REAL(KIND=JWRB), DIMENSION(:,:), INTENT(IN), OPTIONAL :: RALTCOR

          IF(PRESENT(WSEMEAN)) SELF%F_WSEMEAN => WRAP_2D_REAL_FIELD(WSEMEAN)
          IF(PRESENT(WSFMEAN)) SELF%F_WSFMEAN => WRAP_2D_REAL_FIELD(WSFMEAN)
          IF(PRESENT(USTOKES)) SELF%F_USTOKES => WRAP_2D_REAL_FIELD(USTOKES)
          IF(PRESENT(VSTOKES)) SELF%F_VSTOKES => WRAP_2D_REAL_FIELD(VSTOKES)
          IF(PRESENT(PHIEPS)) SELF%F_PHIEPS => WRAP_2D_REAL_FIELD(PHIEPS)
          IF(PRESENT(PHIOCD)) SELF%F_PHIOCD => WRAP_2D_REAL_FIELD(PHIOCD)
          IF(PRESENT(PHIAW)) SELF%F_PHIAW => WRAP_2D_REAL_FIELD(PHIAW)
          IF(PRESENT(TAUOC)) SELF%F_TAUOC => WRAP_2D_REAL_FIELD(TAUOC)
          IF(PRESENT(TAUXD)) SELF%F_TAUXD => WRAP_2D_REAL_FIELD(TAUXD)
          IF(PRESENT(TAUYD)) SELF%F_TAUYD => WRAP_2D_REAL_FIELD(TAUYD)
          IF(PRESENT(TAUOCXD)) SELF%F_TAUOCXD => WRAP_2D_REAL_FIELD(TAUOCXD)
          IF(PRESENT(TAUOCYD)) SELF%F_TAUOCYD => WRAP_2D_REAL_FIELD(TAUOCYD)
          IF(PRESENT(STRNMS)) SELF%F_STRNMS => WRAP_2D_REAL_FIELD(STRNMS)
          IF(PRESENT(ALTWH)) SELF%F_ALTWH => WRAP_2D_REAL_FIELD(ALTWH)
          IF(PRESENT(CALTWH)) SELF%F_CALTWH => WRAP_2D_REAL_FIELD(CALTWH)
          IF(PRESENT(RALTCOR)) SELF%F_RALTCOR => WRAP_2D_REAL_FIELD(RALTCOR)
      END SUBROUTINE INTGT_PARAM_FIELDS_FIELD_INIT
  
      SUBROUTINE INTGT_PARAM_FIELDS_UPDATE_VIEW(SELF, BLOCK_INDEX)
          CLASS(INTGT_PARAM_FIELDS_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), INTENT(IN) :: BLOCK_INDEX

          IF(ASSOCIATED(SELF%F_WSEMEAN)) SELF%WSEMEAN => SELF%F_WSEMEAN%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_WSFMEAN)) SELF%WSFMEAN => SELF%F_WSFMEAN%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_USTOKES)) SELF%USTOKES => SELF%F_USTOKES%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_VSTOKES)) SELF%VSTOKES => SELF%F_VSTOKES%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_PHIEPS)) SELF%PHIEPS => SELF%F_PHIEPS%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_PHIOCD)) SELF%PHIOCD => SELF%F_PHIOCD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_PHIAW)) SELF%PHIAW => SELF%F_PHIAW%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUOC)) SELF%TAUOC => SELF%F_TAUOC%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUXD)) SELF%TAUXD => SELF%F_TAUXD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUYD)) SELF%TAUYD => SELF%F_TAUYD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUOCXD)) SELF%TAUOCXD => SELF%F_TAUOCXD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_TAUOCYD)) SELF%TAUOCYD => SELF%F_TAUOCYD%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_STRNMS)) SELF%STRNMS => SELF%F_STRNMS%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_ALTWH)) SELF%ALTWH => SELF%F_ALTWH%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_CALTWH)) SELF%CALTWH => SELF%F_CALTWH%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_RALTCOR)) SELF%RALTCOR => SELF%F_RALTCOR%GET_VIEW(BLOCK_INDEX)
      END SUBROUTINE INTGT_PARAM_FIELDS_UPDATE_VIEW

      SUBROUTINE SOURCE_CONTRIBS_FIELD_INIT(SELF, FL1, XLLWS, MIJ)
          CLASS(SOURCE_CONTRIBS_FIELD), INTENT(INOUT) :: SELF
          REAL(KIND=JWRB), DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL :: FL1
          REAL(KIND=JWRB), DIMENSION(:,:,:,:), INTENT(IN), OPTIONAL :: XLLWS
          INTEGER(KIND=JWIM), DIMENSION(:,:), INTENT(IN), OPTIONAL :: MIJ

          IF(PRESENT(FL1)) SELF%F_FL1 => WRAP_4D_REAL_FIELD(FL1)
          IF(PRESENT(XLLWS)) SELF%F_XLLWS => WRAP_4D_REAL_FIELD(XLLWS)
          IF(PRESENT(MIJ)) SELF%F_MIJ => WRAP_2D_INT_FIELD(MIJ)
      END SUBROUTINE SOURCE_CONTRIBS_FIELD_INIT
  
      SUBROUTINE SOURCE_CONTRIBS_UPDATE_VIEW(SELF, BLOCK_INDEX)
          CLASS(SOURCE_CONTRIBS_FIELD), INTENT(INOUT) :: SELF
          INTEGER(KIND=JWIM), INTENT(IN) :: BLOCK_INDEX

          IF(ASSOCIATED(SELF%F_FL1)) SELF%FL1 => SELF%F_FL1%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_XLLWS)) SELF%XLLWS => SELF%F_XLLWS%GET_VIEW(BLOCK_INDEX)
          IF(ASSOCIATED(SELF%F_MIJ)) SELF%MIJ => SELF%F_MIJ%GET_VIEW(BLOCK_INDEX)
      END SUBROUTINE SOURCE_CONTRIBS_UPDATE_VIEW

END MODULE YOWFIELD_MOD
