! (C) Copyright 1989- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

      MODULE YOWSPEC

      USE PARKIND_WAVE, ONLY : JWIM, JWRB, JWRU
      USE YOWDRVTYPE, ONLY : FORCING_FIELDS

      IMPLICIT NONE

      INTEGER(KIND=JWIM), ALLOCATABLE :: NSTART(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: NEND(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: NBLKS(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: NBLKE(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: KLENTOP(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: KLENBOT(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: NFROMPE(:) 
      INTEGER(KIND=JWIM) :: NFROMPEMAX
      INTEGER(KIND=JWIM), ALLOCATABLE :: NTOPE(:) 
      INTEGER(KIND=JWIM) :: NTOPEMAX
      INTEGER(KIND=JWIM), ALLOCATABLE :: NIJSTART(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: IJTOPE(:,:) 
      INTEGER(KIND=JWIM) :: NGBTOPE
      INTEGER(KIND=JWIM), ALLOCATABLE :: NTOPELST(:) 
      INTEGER(KIND=JWIM) :: NGBFROMPE
      INTEGER(KIND=JWIM), ALLOCATABLE :: NFROMPELST(:) 
      INTEGER(KIND=JWIM), ALLOCATABLE :: IJ2NEWIJ(:) 

      TYPE(FORCING_FIELDS) :: FF_NOW

      REAL(KIND=JWRB), ALLOCATABLE, DIMENSION(:,:,:,:) :: FL1

!     *NSTART*    INDEX OF THE FIRST POINT OF THE COMPUTATION SUB GRID DOMAIN
!     *NEND*      INDEX OF THE LAST POINT OF THE COMPUTATION SUB GRID DOMAIN
!     *NBLKS*     INDEX OF THE FIRST POINT OF THE SUB GRID DOMAIN (only local points)
!     *NBLKE*     INDEX OF THE LAST POINT OF THE SUB GRID DOMAIN (only local points)
!     *KLENTOP*   LENGTH OF THE MESSAGE SENT BY THE NEXT
!                 SUB GRID DOMAIN (IN GRID POINT UNIT)
!     *KLENBOT*   LENGTH OF THE MESSAGE SENT BY THE PREVIOUS
!                 SUB GRID DOMAIN (IN GRID POINT UNIT)
!     *NFROMPE*   INDICATES HOW MANY HALO POINTS THE LOCAL PE NEEDS
!                 TO GET FROM THE OTHER PE'S.
!     *NFROMPEMAX*MAXIMUM OF NFROMPE
!     *NTOPE*     INDICATES HOW MANY HALO POINTS THE LOCAL PE NEEDS
!                 TO SEND TO THE OTHER PE'S.
!     *NTOPEMAX*  MAXIMUM OF NTOPE
!     *NIJSTART*  INDEX OF THE FIRST HALO POINT FROM A GIVEN PE
!                 IN THE LOCAL HALO BUFFERS WHICH PADS BOTH ENDS OF
!                 THE LOCAL GRID POINT 1-D ARRAY
!     *IJTOPE*    TELLS THE LOCAL PE THE INDEX OF WHICH POINTS IT NEEDS
!                 TO SEND TO THE OTHER PE'S.
!     *NGBTOPE*   TOTAL NUMBER OF PE's TO WHICH INFORMATION WILL BE
!                 SENT FROM THE LOCAL PE VIA MESSAGE PASSING
!     *NTOPELST*  LIST OF THE PE'S TO WHICH INFORMATION WILL BE SENT
!     *NGBFROMPE* TOTAL NUMBER OF PE's FROM WHICH INFORMATION WILL BE
!                 RECEIVED TO THE LOCAL PE VIA MESSAGE PASSING
!     *NFROMPELST*LIST OF THE PE'S FROM WHICH INFORMATION WILL BE
!                 RECEIVED
!     *IJ2NEWIJ*  TRANSFORMS THE OLD INDEX IJ INTO THE NEW IJ AS
!                 DETERMINED IN THE CASE OF 2-D DECOMPOSITION
!                 (SEE MPDECOMP).
!     *FF_NOW*    FORCING FIELDS AT CURRENT TIME
!     *FL1*       FREQUENCY SPECTRUM.
! ----------------------------------------------------------------------

      END MODULE YOWSPEC 
