#!/bin/bash


export FC=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/compilers/bin/nvfortran
export CUDA_TOOLKIT_ROOT_DIR=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0
export CUDACXX=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.8/bin/nvcc
export CUDADIR=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0
export CUDA_HOME=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0
export NVHPC_CUDA_HOME=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0
export CUDA_INCLUDE_DIRS=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/include
export CUDA_INCLUDE=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/include
export CUDA_INC=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/include
export CUDA_LIBRARIES=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/lib64
export CUDA_LIB=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/lib64
export LD_LIBRARY_PATH=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/lib64:$LD_LIBRARY_PATH
export PATH=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/bin/nvcc:$PATH
export CUDA_VERSION=11.0



# Install Field API
cd /ecwam_bundle/ecwam-others/field_api/
ecbuild -DCMAKE_CUDA_COMPILER=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.8/bin/nvcc -DCMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.0/targets/x86_64-linux/lib -B build_11.0
cmake --build build_11.0


# Compile ecwam_gpu
mkdir -p /opt/ecwam_gpu_11.0/build
cd /opt/ecwam_gpu_11.0/build
cmake -DCMAKE_INSTALL_PREFIX=/opt/ecwam_gpu_11.0/install -DCMAKE_C_COMPILER=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/compilers/bin/nvc -DCMAKE_Fortran_COMPILER=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/compilers/bin/nvfortran -DCMAKE_CXX_COMPILER=/opt/nvidia/hpc_sdk/Linux_x86_64/23.9/cuda/11.8/bin/nvcc -DENABLE_OMP=OFF -DENABLE_WAM_LOKI=ON -Dfypp_DIR=/usr/local/lib/python3.10/dist-packages -Dfield_api_DIR=/ecwam_bundle/ecwam-others/field_api/build_11.0 -Dloki_DIR=/ecwam_bundle/ecwam-others/loki/build -Dpyyaml_DIR=/usr/local/lib/python3.10/dist-packages -DCMAKE_Fortran_FLAGS="-acc -Minfo=accel -gpu=cuda11.0" /ecwam_bundle/ecwam/ecwam_naan-phys-gpu
make -j
make install

