from spack.package import *
import os

class Fckit(CMakePackage):
    """Fortran toolkit for interoperating Fortran with C/C++. (ECMWF)"""

    # url = "file://{}/fckit-0.10.0.tar.gz".format(os.getcwd())
    # manual_download = True
    # version("0.10.0", sha256= "59f454ba253d991cc856dd20140b81893e7c364df3f8b6d752f657fab8bb91cd")
    homepage = "https://github.com/ecmwf/fckit"
    git = "https://github.com/ecmwf/fckit.git"
    version("0.10.0", tag="0.10.0")

    variant("eckit", default=False, description="Wrap ecKit functionality")
    variant("final", default=False, description="Enable automatic finalisation for derived types (destructors)")
    depends_on("ecbuild")
    depends_on("python")
    depends_on("cmake")
    depends_on("eckit", when='+eckit')


    def cmake_args(self):
        enable_final = "+final" in self.spec
        args = [
                self.define("ENABLE_FCKIT_FINAL", enable_final),
                ]
        return args
