#!/bin/bash


#SBATCH --ntasks-per-node=4
#SBATCH --cpus-per-task=8
#SBATCH --gres=gpu:4
#SBATCH --exclusive
#SBATCH -p boost_usr_prod
##SBATCH -q boost_qos_lprod
#SBATCH -A DE360_leonardo
export OMP_NUM_THREADS=8


NODES=$1
TASKS=$(( $1 * 4 ))


# weird command to get the script directory when submitting a job with sbatch
script_dir=$(scontrol show job "$SLURM_JOB_ID" | awk -F= '/Command=/{sub(/\/[^\/]+$/, "", $2); print $2}')
base_path=$(cd "$script_dir/.." && pwd -P)


CONTAINER="${2:-$base_path/images/container_ecwam.sif}"
export CONTAINER_PATH=$(realpath $CONTAINER)


# setup environment specifying the container
. $script_dir/setup-env-Leo.gpu.sh  $CONTAINER_PATH


export LAUNCH="mpirun -np ${TASKS}"
$base_path/ecwam_scripts/ecwam_run_model.sh --config=$base_path/tests/etopo1_oper_an_fc_O320.yml
