#!/bin/bash


base_path="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd -P)"


# Create a default definition file from a template
$base_path/definitions/template.sh
# The default output definition file is 
def_file="$base_path/definitions/ecwam_nvhpc-23.1_cuda-11.8.def"



mkdir -p images
if [ "$1" == "--sandbox" ]; then
    # The default output container is set to 
    container="$base_path/images/container_ecwam.img"
    echo "About to create the container image in sandbox format at $container"
    echo "Please allow sudo rights."
    sudo -E singularity build --sandbox $container $def_file 2>&1 | tee output_build.log
    echo "The container image has been created in the following location: $container"
else
    # The default output container is set to 
    container="$base_path/images/container_ecwam.sif"
    echo "About to create the container image in Singularity Image Format at $container"
    echo "Please allow sudo rights."
    sudo -E singularity build $container $def_file 2>&1 | tee output_build.log
    echo "The container image has been created in the following location: $container"
fi
