## Directory overview

In this directory one can find the scripts used for the execution of the model. In particular, this usually takes place in three stages, the *preproc*, *preset* and *run*, governed by three environment variables respectively, `$PREPROC`, `$PRESET` and `$MODEL`(`$CHIEF`). These variables can either take default values, being parsed, or set a priori. Whereas in the host version these variables would point to the model binaries, here we export them to point to Singularity commands executing the *ecwam* binaries from within the container, namely

    export PREPROC="singularity exec $CONTAINER_PATH /opt/ecwam/install/bin/ecwam-preproc"
    export PRESET=" singularity exec $CONTAINER_PATH /opt/ecwam/install/bin/ecwam-preset"   
    export MODEL="  singularity exec $CONTAINER_PATH /opt/ecwam/install/bin/ecwam-chief"
    export CHIEF="  singularity exec $CONTAINER_PATH /opt/ecwam/install/bin/ecwam-chief"

The above exports must be executed before launching; we perform such operation when sourcing the setup for the current environment, see the `/ecwam-container/configuration_files` directory for further details.

All in all minimal changes are needed to the original *ecwam* launch scripts to account for this discrepancy, namely:
+ in `ecwam_scripts/ecwam_runtime.sh` we comment out the lines setting the above environment variables (see lines 25-33)
+ in `ecwam_scripts/ecwam_run_{preproc,preset,model}.sh` there where multiple instances of `which ${PREPROC,PRESET,MODEL}`. Whereas in the original code these variables would point to binaries of the *ecwam* model, now they point to singularity commands pointing to the binaries within the container. For these reasons the `which` command does not make sense any more, and it is sufficient to remove it.
+ in `ecwam_scripts/ecwam_parameters.py` we modified line 24, the path to `parameters_file`, which is now placed in the same directory of the launch scripts (rather than `../parameters.yml` one directory above)