#!/bin/bash

base_path="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd -P)"

CONTAINER="${1:-$base_path/images/container_ecwam.sif}"
export CONTAINER_PATH=$(realpath $CONTAINER)
echo $CONTAINER_PATH


# Sourcing the setup file, modify accordingly
echo "Setting environment..."
. $base_path/configuration_files/setup-env-local.sh $CONTAINER_PATH


# Run preproc and preset
export LAUNCH=""
echo -e "\nRunning the preproc...\n"
ecwam_scripts/ecwam_run_preproc.sh  --config=$base_path/tests/etopo1_oper_an_fc_O48.yml
echo -e "\nRunning the preset...\n"
ecwam_scripts/ecwam_run_preset.sh   --config=$base_path/tests/etopo1_oper_an_fc_O48.yml


# Run the model serially
NTASKS=4
export CHIEF="singularity exec $CONTAINER_PATH mpirun -np $NTASKS /opt/ecwam/install/bin/ecwam-chief"
export MODEL="singularity exec $CONTAINER_PATH mpirun -np $NTASKS /opt/ecwam/install/bin/ecwam-chief"
echo -e "\nRunning the model serially...\n"
ecwam_scripts/ecwam_run_model.sh    --config=$base_path/tests/etopo1_oper_an_fc_O48.yml


